unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, LPTIO,
  ExtCtrls, StdCtrls, ComCtrls, Spin, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    GroupBox2: TGroupBox;
    TrackBar1: TTrackBar;
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    SpeedButton1: TSpeedButton;
    Edit2: TEdit;
    Timer1: TTimer;
    Edit3: TEdit;
    Label3: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private declarations }
    Lpt : TLptPortConnection;
  public
    { Public declarations }
    function GetCurrentPort : byte;     //   ComboBox1     
  function GetCurrentRegister : byte; //   ComboBox2     



 //*********************PIN**************************************************
     function Pin2 : boolean;
     function Pin3 : boolean ;
     function Pin4 : boolean ;
     function Pin5 : boolean ;
     function Pin6 : boolean ;
     function Pin7 : boolean ;
     function Pin8 : boolean ;
     function Pin9 : boolean ;

     function Pin1 : boolean ;
     function Pin14 : boolean ;
     function Pin16 : boolean ;
     function Pin17 : boolean ;

     function Pin11 : boolean ;
     function Pin10 : boolean ;
     function Pin12 : boolean ;
     function Pin13 : boolean ;
     function Pin15 : boolean ;
   //**************************************************************************

     function Bits : boolean ; //--

  end;

var
  Form1: TForm1;

implementation
{       }
 Var stop:boolean;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var msg : AnsiString;
begin
 Lpt := TLptPortConnection.Create;
 if not Lpt.Ready then
  begin {    --    }
  msg := '    Lpt,   ERROR,   = ' + IntToStr(GetLastError());
  Application.MessageBox(PChar(msg),'ERROR',MB_OK);
  Application.Terminate; // 
  end;
 //         ComboBox-e
 ComboBox1.Items.Clear;
 ComboBox1.Text := '';
 if Lpt.IsPortPresent(LPT1) then ComboBox1.Items.Add('$3BC');
 if Lpt.IsPortPresent(LPT2) then ComboBox1.Items.Add('$378'); //-: $378   LPT2! 
 if Lpt.IsPortPresent(LPT3) then ComboBox1.Items.Add('$278');

 if 0<>ComboBox1.Items.Count then ComboBox1.ItemIndex := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject); //  
begin
 Lpt.Destroy;
{    ,    }
end;




function TForm1.GetCurrentPort : byte;     //   ComboBox1     
begin
 if '$3BC' = ComboBox1.Text then
  GetCurrentPort:=LPT1
                            else
  if '$378' = ComboBox1.Text then
   GetCurrentPort:=LPT2      else
   GetCurrentPort:=LPT3;
end;


 //-------  ------------

function TForm1.GetCurrentRegister : byte; //   ComboBox2     
begin
 if '' = ComboBox2.Text then
  GetCurrentRegister:=LPT_DATA_REG
                              else
  if '' = ComboBox2.Text       then
   GetCurrentRegister:=LPT_STATE_REG    else
   GetCurrentRegister:=LPT_CONTROL_REG;
end;


//***********  - PIN - *******************************************

      
 function TForm1.Pin2 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (1 = (1 and Lpt.ReadPort( (GetCurrentPort) ,0))) ;
     Pin2 := d;
 end;

 function TForm1.Pin3 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (2 = (2 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin3 := d;
 end;

 function TForm1.Pin4 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (4 = (4 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin4 := d;
 end;

 function TForm1.Pin5 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (8 = (8 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin5 := d;
 end;

 function TForm1.Pin6 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (16 = (16 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin6 := d;
 end;

 function TForm1.Pin7 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (32 = (32 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin7 := d;
 end;

 function TForm1.Pin8 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (64 = (64 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin8 := d;
 end;

 function TForm1.Pin9 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (128 = (128 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin9 := d;
 end;
//-------------------------------------------------------

 
 function TForm1.Pin1 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor (STROBE  = (STROBE  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin1 := d;
 end;
 
 function TForm1.Pin14 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor (AUTOFEED  = (AUTOFEED  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin14 := d;
 end;
 
 function TForm1.Pin16 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (INIT  = (INIT  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin16 := d;
 end;
 
 function TForm1.Pin17 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor (SELECTIN  = (SELECTIN  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin17 := d;
 end;

 //--------------------------------------------------------
 function TForm1.Pin11 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor(BUSY = (BUSY and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin11 := d;
 end;

  function TForm1.Pin10 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(ACK  = (ACK  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin10 := d;
 end;

 function TForm1.Pin12 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(PAPEREND  = (PAPEREND  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin12 := d;
 end;

 function TForm1.Pin13 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(SELECT = (SELECT  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin13 := d;
 end;

 function TForm1.Pin15 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(ERROR  = (ERROR  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin15 := d;
 end;

//******************************************************************************
{-------  XP: lptwdmio.sys      ------------- }
{---------------------------- -------------------------------------------}


function TForm1.Bits : boolean ; //--   (1-2-4-8-16-32-64-128)
 Var
 d : boolean;
 begin
     d := true; {     - xor  and }
     d := d and ((SpinEdit1.Value)  = ((SpinEdit1.Value)  and Lpt.ReadPort(GetCurrentPort,GetCurrentRegister))) ;
     Bits := d;
 end;




procedure TForm1.Button1Click(Sender: TObject);
begin
Stop:=true; //-- 
Edit3.Color := clBtnFace;
end;

procedure TForm1.Button2Click(Sender: TObject);
 begin
 
 Edit3.Color := claqua; //--
 stop:=false; //-- 
 While not stop do //-- ,     :
  begin
  {     Pin ,    SpinEdit1; }
  Lpt.WritePort (GetCurrentPort,GetCurrentRegister,((SpinEdit1.Value) xor
  Lpt.ReadPort( (GetCurrentPort) ,GetCurrentRegister) )); {   GetCurrentRegister .   }

  if RadioButton2.Checked = true then Sleep(TrackBar1.Position div 10) else //--   10
  if RadioButton3.Checked = true then Sleep(TrackBar1.Position div 100)else //--   100
  Sleep(TrackBar1.Position); //--     ( )

  { --------------   (  SpinEdit1 )--------------------}
  if Edit2.Tag = 0 then
  begin
  if Bits = true then Edit2.Text := IntToStr(StrToInt(Edit2.Text)+1);
  Edit2.Tag :=1;
  end;
  if Bits = false then Edit2.Tag := 0;
  {-----------------------------------------------------------------------}

  Application.ProcessMessages; //--   ,  
  end;

 end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
stop := true; //--       ()
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
// Timer2.Interval := TrackBar1.Position;
 Edit1.Text := IntToStr(TrackBar1.Position);   {   }
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
Edit1.Text := IntToStr(TrackBar1.Position);
Application.HintColor := cllime;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  MessageBox(Handle,PChar( ' LPT  -  .   US4LEH  http:valery-us4leh.narod.ru '),
  PChar(' '),MB_ICONINFORMATION + MB_OK +MB_DEFBUTTON2);

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Edit3.Text := edit2.Text; //-- 
 Edit2.Text := '0'; //--   0 (   = 1  )
end;

end.
